
/*

"E2xB" COPYRIGHT NOTICE, LICENSE AND DISCLAIMER.

Copyright 2003 by Kostas G. Anagnostakis, Evangelos P. Markatos,
Polyhronakis Mixalhs, Antonatos Spiros


Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, provided 
that the above copyright notice appear in all copies and that both the 
copyright notice and this permission notice and warranty disclaimer appear 
in supporting documentation, and that the names of the authors not be used 
in advertising or publicity pertaining to distribution of the software without 
specific, written prior permission.

The authors disclaim all warranties with regard to this software, including all 
implied warranties of merchantability and fitness.  In no event shall we be liable 
for any special, indirect or consequential damages or any damages whatsoever 
resulting from loss of use, data or profits, whether in an action of contract,
negligence or other tortious action, arising out of or in connection with the
use or performance of this software.

*/

#define EXCLSTATS 1 
#define MAXPOOLSZ 2*1024*1024	/* local mem pool */
#define MAXSIZE 16384 	  /* dimensions for occurence bitmap (currently 2^14 */
#define MAXTOSEARCH 64
#define HSIZE (14-8)
#define EREGISTER register
#define INLINE inline
#define MPAT(x) (char *)((void *)x+sizeof(exb_pat_struct))

void *exbpmalloc(size_t foo);
int exbAddPatternEx(void *ps, unsigned char *P, int m, unsigned noCase, unsigned offset, unsigned depth, int ID, int IID);
void * exbNew();

